﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using Arction.WinForms.Charting.SeriesXY;

namespace PointCountLimitExceptionSample
{
    public partial class Form1 : Form
    {
        private readonly FreeformPointLineSeries _freeformPointLineSeries;
        private readonly Random _random = new Random();

        public Form1()
        {
            InitializeComponent();
            var lc = lightningChartUltimate1;
            var view = lc.ViewXY;
            var xAxis = view.XAxes.First();
            var yAxis = view.YAxes.First();

            lc.BeginUpdate();
            _freeformPointLineSeries = new FreeformPointLineSeries(view, xAxis, yAxis)
            {
                PointCountLimitEnabled = true,
                PointCountLimit = 500000
            };
            view.FreeformPointLineSeries.Add(_freeformPointLineSeries);
            lc.EndUpdate();
        }

        private void button_Click(object sender, EventArgs e)
        {
            lightningChartUltimate1.BeginUpdate();
            var xValues = new List<double>();
            var yValues = new List<double>();
            for (int i = 0; i < 2000; i++)
            {
                xValues.Add(_random.NextDouble());
                yValues.Add(_random.NextDouble());
            }
            _freeformPointLineSeries.AddPoints(xValues.ToArray(), yValues.ToArray(), true);
            lightningChartUltimate1.EndUpdate();
            
            lightningChartUltimate1.BeginUpdate();
            _freeformPointLineSeries.PointCountLimit = 5000;
            lightningChartUltimate1.EndUpdate();
        }
    }
}
